/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2014, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_ln
#define headerfile_winix_functions_ln

#include "functionbase.h"

namespace Winix
{


namespace Fun
{


class Ln : public FunctionBase
{
public:

	Ln();
	bool HasAccess();
	void MakePost();

	bool CreateSymbolicLink(long parent_id, const wchar_t * link_to, const wchar_t * url, bool link_redirect = true);
	bool CreateSymbolicLink(long parent_id, const std::wstring & link_to, const std::wstring & url, bool link_redirect = true);
	bool CreateHardLink(const std::vector<Item*> & dirs, const std::wstring & link_to, const std::wstring & url);


private:

	Item item;
	std::wstring link_to;
	std::vector<Item*> dir_tab;

	void CreateSymbolicLink(const std::wstring & link_to);
	void CreateHardLink(const std::wstring & link_to);

};


} // namespace

} // namespace Winix

#endif
